
#include "iodefine.h"
#include "ecu_init.h"
#include "sci.h"
#include "intervaltimer.h"

volatile unsigned char SCIRXERR;

void sci_init(void)
{
	unsigned int i;
	
	PFC.PACRL1.BIT.PA3MD=1;	// o̓s̐ݒ
	PFC.PACRL2.BIT.PA4MD=1;
	
	STB.CR3.BIT._SCI1=0;	// W[Xgbv[h
	SCI1.SCSMR.BYTE=0x00;	//  8bit peBȂ Xgbvrbg1 }`vZbT֎~ CKS=0
	SCI1.SCSDCR.BYTE=0xF2;	// 1111 0010 LSB t@[Xg
	SCI1.SCBRR=IOCLK/(32*19200)-1;	 // {[[g 19200bps
	
	for (i=0; i<1000000; i++) wdtclr();	// 1rbgԈȏ҂
	
	SCI1.SCSCR.BYTE=0x30;	// 0011 0000 MJn 荞݋֎~
	
	//SCI1.SCSPTR.BIT.EIO=1;	// RXI֎~ERI
	//SCI1.SCSCR.BIT.RIE=1;	// MG[荞ERI
	
}

void putch(char a)
{
	unsigned char temp;
	
	while(SCI1.SCSSR.BIT.TDRE==0)wdtclr();	// Mobt@ɂȂ܂ő҂

	temp=SCI1.SCSSR.BIT.TDRE;	// ̍s͖ĂǂǁAƓȂ
	SCI1.SCSSR.BIT.TDRE=0;		// Mobt@GveBtONA
	SCI1.SCTDR=a;
}

char getch(void)
{
	unsigned int timeout;
	unsigned char temp,a;
	
	timeout=TIMER+10;	// ^CAEg10*0.1b=1b
	
	SCIRXERR=0;
	while(SCI1.SCSSR.BIT.RDRF==0)	// M܂ő҂
	{
		wdtclr();
		
		if((timeout==TIMER)
		||(SCIRXERR==1)
		||(SCI1.SCSSR.BIT.ORER==1)
		||(SCI1.SCSSR.BIT.FER==1)
		||(SCI1.SCSSR.BIT.PER==1))	// ^CAEgAG[Nƒf
		{
			SCIRXERR=1;
			if(SCI1.SCSSR.BIT.ORER==1)SCI1.SCSSR.BIT.ORER=0;	// MG[tOĂƎMȂ̂ŁAtONA
			if(SCI1.SCSSR.BIT.FER==1)SCI1.SCSSR.BIT.FER=0;		// iG[𖳎j
			if(SCI1.SCSSR.BIT.PER==1)SCI1.SCSSR.BIT.PER=0;

			return 0;
		}
	}

	a=SCI1.SCRDR;
	
	temp=SCI1.SCSSR.BIT.RDRF;
	SCI1.SCSSR.BIT.RDRF=0;	//	MtONA
	
	return a;
}

// MG[荞
/*void interrupt_sci1err(void)
{
	char a;
	//if(SCI1.SCSSR.BIT.ORER==1)SCI1.SCSSR.BIT.ORER=0;	// MG[tOĂƎMȂ̂ŁAtONA
	//if(SCI1.SCSSR.BIT.FER==1)SCI1.SCSSR.BIT.FER=0;		// iG[𖳎j
	//if(SCI1.SCSSR.BIT.PER==1)SCI1.SCSSR.BIT.PER=0;
	a=SCI1.SCSSR.BIT.ORER;
	SCI1.SCSSR.BIT.ORER=0;
	
	a=SCI1.SCSSR.BIT.FER;
	SCI1.SCSSR.BIT.FER=0;
	
	a=SCI1.SCSSR.BIT.PER;
	SCI1.SCSSR.BIT.PER=0;
	
	SCIRXERR=1;
}
*/

char kbhit(void)
{
	return SCI1.SCSSR.BIT.RDRF;	// Mobt@ɂȂɂĂ1
}

/*void puts(char* a)

	while(*a) putch(*a++);
}*/
void puts(char a[])
{
	short count=0;
	while(a[count]!=0)
	{
		putch(a[count]);
		count++;
	}
}

char tonum(unsigned char a)
{
	a=a&0x0F;
	return a;
}

void putint(unsigned int a)
{
	putch(a/10000+0x30);
	a=a%10000;
	putch(a/1000+0x30);
	a=a%1000;
	putch(a/100+0x30);
	a=a%100;
	putch(a/10+0x30);
	a=a%10;
	putch(a+0x30);
}
